#property copyright "ActFX_Programmer"
#property link      "Skype ActFX_Programmer"


//--- extern variables
extern int period_sec = 1;

//--- global variables
int pause = 0;
int orders_total = 0;
int order_ticket[];
int order_open_time[];
int order_type[];
double order_lots[];
string order_symbol[];
double order_open_price[];
double order_stop_loss[];
double order_take_profit[];
string order_comment[];
datetime time_local = 0;
int index;
string Buffer[100];
string str;
int handle;
int i;

#define FILE_NAME "MasterOrders.txt"
#define DELIM     ";"

//+------------------------------------------------------------------+
string IntToStr(int value)
//+------------------------------------------------------------------+
{
   return(DoubleToStr(value, 0));
}
//+------------------------------------------------------------------+
string TimeToString(datetime time)
//+------------------------------------------------------------------+
{
   return(TimeToStr(time, TIME_DATE|TIME_MINUTES|TIME_SECONDS));
}
//+------------------------------------------------------------------+
int init()
//+------------------------------------------------------------------+
{
   pause = 1000 * period_sec;
   Print("Advisor started");
   return (0);
}
//+------------------------------------------------------------------+
int deinit()
//+------------------------------------------------------------------+
{
   Print("Advisor stoped");
   return (0);
}
//+------------------------------------------------------------------+
int start()
//+------------------------------------------------------------------+
{
   while (!IsStopped() && IsExpertEnabled() && IsTradeAllowed())
   {
      Sleep(pause);
      
      time_local = TimeLocal();

      if (!ZapOrd()) return;
      
      index = 0;

      Buffer[index] = DoubleToStr(orders_total, 0);
      index++;
      
      Buffer[index] = TimeToString(time_local);
      index++;
      for (i = 0; i < orders_total; i++)
      {
         str = IntToStr(order_ticket[i]) + DELIM + 
         TimeToString(order_open_time[i])+ DELIM + 
         IntToStr(order_type[i]) + DELIM + 
         DoubleToStr(order_lots[i], 2) + DELIM + 
         order_symbol[i] + DELIM + 
         DoubleToStr(order_open_price[i],4) + DELIM + 
         DoubleToStr(order_stop_loss[i],4) + DELIM + 
         DoubleToStr(order_take_profit[i],4) + DELIM + 
         order_comment[i];
         Buffer[index] = str;
         index++;
      }
      
      Buffer[index] = TimeToString(time_local);
      index++;

      handle = FileOpen(FILE_NAME, FILE_CSV|FILE_WRITE, DELIM);

      if (handle != -1)
      {
         for (i = 0; i < index; i++)
            FileWrite(handle, Buffer[i]);
         FileClose(handle);
         Comment("\n", "Master:  ", TimeToString(TimeLocal()) );
      }
   }
   return (0);
}

//+------------------------------------------------------------------+
bool ZapOrd()
//+------------------------------------------------------------------+
{
   orders_total = OrdersTotal();
   ArrayResize(order_ticket, orders_total);
   ArrayResize(order_open_time, orders_total);
   ArrayResize(order_type, orders_total);
   ArrayResize(order_lots, orders_total);
   ArrayResize(order_symbol, orders_total);
   ArrayResize(order_open_price, orders_total);
   ArrayResize(order_stop_loss, orders_total);
   ArrayResize(order_take_profit, orders_total);
   ArrayResize(order_comment, orders_total);
   
   for (int i=0; i<orders_total; i++)
   {
      if (OrderSelect(i, SELECT_BY_POS))
      {
         order_ticket[i]      = OrderTicket();
         order_open_time[i]   = OrderOpenTime();
         order_type[i]        = OrderType();
         order_lots[i]        = OrderLots();
         order_symbol[i]      = StringSubstr(OrderSymbol(),0,6);
         order_open_price[i]  = OrderOpenPrice();
         order_stop_loss[i]   = OrderStopLoss();
         order_take_profit[i] = OrderTakeProfit();
         order_comment[i]     = OrderComment();
      }
      else
      {
         Print("  ");
         return (false);
      }
   }
   return (true);
}